/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20221106

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "gram.y"

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 71 "gram.y"
typedef union YYSTYPE {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 120 "gram.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define SEMI 265
#define MOD 266
#define OC 267
#define CC 268
#define DOLLAR 269
#define DOTDOTDOT 270
#define ENDFILE 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FOREIGN 282
#define FILET 283
#define MUTEX 284
#define SEMAPHORE 285
#define CONTINUATION 286
#define THREAD 287
#define VOID 288
#define BOOL 289
#define FUNCTION 290
#define FUNC 291
#define EXCEPTION 292
#define RAISE 293
#define TYPEDEF 294
#define IMPORT 295
#define NEW 296
#define ANONINIT 297
#define NAMESPACE 298
#define PUBLIC 299
#define PROTECTED 300
#define EXTEND 301
#define WHILE 302
#define DO 303
#define FOR 304
#define SWITCH 305
#define BREAK 306
#define CONTINUE 307
#define RETURNTOK 308
#define FORK 309
#define CASE 310
#define DEFAULT 311
#define TWIXT 312
#define NAME 313
#define TYPENAME 314
#define NAMESPACENAME 315
#define COMMAND 316
#define NAMECOMMAND 317
#define TEN_NUM 318
#define OCTAL0_NUM 319
#define OCTAL_NUM 320
#define BINARY_NUM 321
#define HEX_NUM 322
#define TEN_FLOAT 323
#define OCTAL0_FLOAT 324
#define OCTAL_FLOAT 325
#define BINARY_FLOAT 326
#define HEX_FLOAT 327
#define CHAR_CONST 328
#define STRING_CONST 329
#define POLY_CONST 330
#define THREAD_CONST 331
#define COMMENT_CONST 332
#define VOIDVAL 333
#define BOOLVAL 334
#define DARROW 335
#define ISTYPE 336
#define HASMEMBER 337
#define POUND 338
#define COMMA 339
#define ASSIGN 340
#define ASSIGNPLUS 341
#define ASSIGNMINUS 342
#define ASSIGNTIMES 343
#define ASSIGNDIVIDE 344
#define ASSIGNDIV 345
#define ASSIGNMOD 346
#define ASSIGNPOW 347
#define ASSIGNSHIFTL 348
#define ASSIGNSHIFTR 349
#define ASSIGNLXOR 350
#define ASSIGNLAND 351
#define ASSIGNLOR 352
#define ASSIGNOR 353
#define ASSIGNAND 354
#define QUEST 355
#define COLON 356
#define OR 357
#define AND 358
#define LOR 359
#define LXOR 360
#define LAND 361
#define EQ 362
#define NE 363
#define LT 364
#define GT 365
#define LE 366
#define GE 367
#define SHIFTL 368
#define SHIFTR 369
#define PLUS 370
#define MINUS 371
#define TIMES 372
#define DIVIDE 373
#define DIV 374
#define POW 375
#define STARSTAR 376
#define POW2 377
#define POW3 378
#define UNIONCAST 379
#define UMINUS 380
#define BANG 381
#define FACT 382
#define LNOT 383
#define INC 384
#define DEC 385
#define STAR 386
#define AMPER 387
#define THREADID 388
#define OS 389
#define CS 390
#define DOT 391
#define ARROW 392
#define STAROS 393
#define CALL 394
#define OP 395
#define CP 396
#define POINTER 397
#define COLONCOLON 398
#define IF 399
#define TRY 400
#define NONL 401
#define ELSE 402
#define CATCH 403
#define NL 404
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   96,   96,   99,   99,   99,  100,  101,   98,
  102,  103,  103,  104,  104,  105,  105,   97,   97,   97,
   97,   97,   97,   97,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   60,   60,  106,  107,    8,  108,  109,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  111,   16,   16,   16,   16,   70,   70,   19,   19,
   18,   12,   12,   13,    9,    9,  112,   10,   20,   20,
  110,  110,  113,   81,   82,   82,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   46,   46,
   46,   46,   46,   46,   45,   45,   45,   45,   45,   45,
   47,   47,   47,   47,   47,   47,   44,   44,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   51,   48,   48,   49,   49,   50,   50,   52,   52,   53,
   53,   54,   54,   56,   56,   55,   55,   55,   55,   57,
   57,   58,   58,   59,   59,   61,   61,   62,   62,   63,
   63,   66,   64,   64,   65,   65,   67,   67,   68,   68,
   69,   69,   71,   71,   77,   77,   72,   72,   73,   73,
   75,   75,   76,   76,   11,  114,   11,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   79,
   79,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   78,   78,   78,   78,   78,   80,   80,   80,   80,
   80,   83,   83,   83,   84,   84,   29,   29,   30,   30,
   31,   32,   85,   85,   86,   86,   87,   87,   87,   88,
   89,   89,   90,   90,   91,   91,   92,   93,   93,   94,
   94,   94,   94,   95,   95,   95,   95,
};
static const YYINT yylen[] = {                            2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    2,    2,    4,
    4,    4,    4,    0,    2,    2,    2,    2,    2,    3,
    1,    4,    4,    4,    3,    1,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    3,    1,    3,    1,    3,    1,    4,
    0,    4,    0,    1,    0,    1,    1,    1,    1,    1,
    0,    1,    1,    1,    1,    3,    2,    3,    2,    2,
    1,    3,    2,    1,    3,    2,    2,    1,    1,    0,
    1,    0,    1,    2,    1,    3,    1,    0,    3,    1,
    1,    0,    3,    2,    3,    0,    2,    3,    7,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    2,    2,    3,    3,    5,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    6,    8,    8,    8,    3,    6,    2,    1,
    3,    3,    4,    4,    4,    6,    6,    3,    3,    1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    0,    5,    9,    2,    1,    3,    1,
    1,    0,    3,    1,    1,    1,    1,    2,    0,    4,
    3,    1,    3,    2,    1,    1,    4,    3,    1,    3,
    3,    4,    4,    1,    1,    1,    2,
};
static const YYINT yydefred[] = {                         2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  176,  177,  178,  179,  149,
  150,  151,  152,  153,  161,  154,  155,  156,  157,  158,
  159,  160,    8,    0,  182,  183,  185,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  258,  260,  259,  261,  262,  263,  265,  264,  266,
  267,  268,  269,  270,  271,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  280,    0,    8,
    8,  257,   55,   10,   54,   46,    9,  146,    0,   93,
   45,    0,    0,    0,    0,  141,    0,    0,    0,    0,
   38,    0,    0,    0,    0,    0,    6,    7,    5,    4,
    0,    0,    0,  307,  309,  308,  310,  311,  220,   48,
  279,  290,    0,    0,    0,   45,   45,   45,   45,   62,
   63,    0,    0,    0,    0,    0,  201,    0,    0,   45,
   42,   10,  207,    0,   10,    0,   25,    0,    0,    0,
  138,    0,  139,    0,    0,  136,    0,  137,    0,    0,
    0,    0,    0,  272,    0,    0,    0,    0,   45,    0,
    0,    9,   75,   35,    0,   37,    0,    0,    8,    0,
    0,  204,    0,   45,    0,    0,   12,  128,    0,    0,
  135,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    8,    8,    8,  174,    0,    8,   65,    0,    0,
    0,  306,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  241,  242,  228,  230,
  232,    0,    0,    0,    0,    0,    0,    0,   46,    0,
    0,    8,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  117,   64,    0,    0,    0,    0,
   34,   30,   32,   31,    0,    0,    0,    0,    0,    0,
    0,    0,  282,    0,    0,  281,    0,    0,   79,   83,
   20,   56,   41,   86,   46,   85,    0,   95,   94,    0,
    0,    0,  120,    0,    0,    0,  140,  277,  167,    0,
    0,    0,    0,    0,  187,    0,    0,    0,  129,  138,
  139,  136,  137,    0,    0,  127,    0,    0,    0,    0,
    0,   10,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  288,  289,    0,    0,    0,
  211,    0,    0,    0,   47,   50,   45,    0,  142,    0,
  143,    0,  144,  122,    0,    0,    0,    0,    0,    0,
   14,    0,  209,    0,   27,   33,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   67,   89,
   88,    0,  119,    0,    0,  193,    0,  121,    0,    0,
  344,  346,  345,  124,  118,    0,    8,   93,    0,    0,
    0,    0,    0,  190,  186,  199,    0,  189,  145,   45,
  114,    0,    0,    0,    0,    0,    0,  126,   44,   72,
    0,    0,  284,  283,    0,  214,  285,   49,    0,    0,
    0,  109,    0,    0,    0,    0,    0,    0,    0,   21,
   22,    0,    0,   45,  164,   45,   45,  168,    0,   46,
    0,   80,    0,   82,    0,  197,    0,  196,  347,    0,
    0,    0,    0,    0,    0,  324,    0,  332,    0,  339,
  326,  115,    0,    0,  133,  130,  166,  131,  132,  188,
    0,    9,    0,  113,    0,    0,    9,    0,   19,    0,
  213,    0,  170,  172,   69,    0,    0,    0,    0,    0,
    0,  286,  287,    0,    0,    0,    0,  273,    0,   45,
    0,  195,    0,    0,  334,  336,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  192,   46,    0,    0,   46,
   70,  111,    9,   40,   74,    0,    0,   46,    0,   77,
   46,   46,    0,    0,    0,   46,  327,    0,   46,    0,
   46,  312,    0,    0,   90,    0,  341,  321,  322,    0,
    0,  333,    0,  323,    0,    0,  331,  330,    0,    0,
  338,  337,  219,    0,  217,   93,   71,    0,    0,    9,
   46,    9,    9,    0,    0,   46,    0,    0,  328,  276,
  274,  313,  275,    0,   93,    0,    0,    0,  343,  315,
    0,    0,    9,   46,    0,   57,    9,   59,   60,    0,
    0,   97,   98,   46,   53,    0,    0,  319,    9,   73,
    9,   45,    0,   46,    0,   58,    0,  101,    9,   46,
    0,  318,   46,   68,   61,    0,    0,  102,  103,  100,
   76,   84,  317,    0,    0,  106,  316,  107,    0,    0,
   46,  105,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  406,  256,  271,  404,  502,  503,  508,  504,  260,  261,
  262,  265,  266,  267,  269,  272,  273,  274,  275,  276,
  277,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  293,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  333,  334,  336,  337,  358,  361,  371,
  372,  376,  381,  383,  384,  385,  389,  391,  395,  399,
  400,  407,  414,  421,  422,  423,  424,  433,  434,  444,
  445,  448,  450,  451,  453,  457,  461,  463,  464,  465,
  466,  477,  480,  483,  514,  516,  265,  271,  404,  505,
  267,  267,  267,  318,  319,  320,  321,  322,  486,  512,
  485,  486,  506,  407,  434,  506,  506,  506,  506,  265,
  265,  261,  262,  448,  464,  475,  477,  451,  480,  506,
  398,  478,  479,  480,  409,  410,  411,  412,  395,  395,
  451,  480,  451,  480,  480,  451,  480,  451,  480,  480,
  480,  480,  480,  390,  389,  414,  451,  477,  506,  506,
  504,  513,  507,  314,  315,  466,  487,  519,  512,  290,
  313,  440,  442,  291,  370,  391,  404,  509,  389,  395,
  452,  467,  315,  358,  361,  372,  376,  395,  434,  450,
  451,  292,  294,  295,  461,  462,  298,  265,  338,  504,
  266,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  376,  377,  378,  381,  384,
  385,  389,  391,  392,  393,  395,  484,  339,  420,  421,
  477,  305,  450,  459,  450,  460,  313,  439,  313,  395,
  512,  512,  512,  512,  313,  265,  512,  504,  339,  504,
  339,  313,  314,  315,  413,  480,  480,  372,  451,  455,
  458,  480,  396,  391,  396,  396,  512,  267,  422,  425,
  509,  507,  398,  265,  415,  416,  518,  332,  488,  470,
  506,  313,  395,  340,  447,  512,  451,  313,  270,  451,
  454,  455,  456,  458,  396,  451,  468,  469,  452,  451,
  451,  451,  451,  451,  315,  509,  506,  506,  506,  450,
  506,  477,  404,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  480,  480,  480,  480,  480,  480,
  480,  480,  480,  480,  458,  313,  313,  458,  480,  481,
  482,  480,  480,  513,  515,  420,  506,  439,  268,  439,
  268,  339,  268,  395,  478,  395,  421,  395,  395,  395,
  265,  510,  479,  510,  411,  398,  339,  339,  390,  339,
  390,  390,  339,  313,  512,  395,  420,  418,  513,  414,
  426,  507,  396,  450,  451,  471,  473,  395,  267,  480,
  490,  494,  498,  501,  339,  449,  395,  472,  390,  390,
  339,  390,  390,  313,  396,  270,  339,  474,  396,  313,
  313,  314,  441,  446,  451,  407,  408,  509,  315,  466,
  504,  356,  390,  390,  339,  474,  396,  268,  512,  265,
  265,  439,  396,  477,  302,  475,  476,  477,  475,  404,
  404,  451,  313,  396,  372,  396,  396,  458,  396,  501,
  477,  268,  403,  419,  340,  313,  339,  474,  268,  313,
  335,  389,  391,  480,  491,  492,  495,  496,  499,  500,
  501,  440,  470,  487,  452,  452,  270,  452,  452,  468,
  512,  265,  339,  314,  441,  339,  265,  517,  404,  480,
  482,  395,  459,  460,  265,  396,  395,  265,  396,  396,
  265,  396,  396,  512,  512,  512,  480,  513,  396,  407,
  480,  471,  340,  480,  497,  501,  512,  313,  335,  339,
  511,  339,  511,  339,  511,  396,  417,  507,  520,  467,
  507,  441,  265,  408,  507,  267,  477,  421,  477,  476,
  421,  427,  514,  475,  267,  493,  494,  267,  490,  267,
  489,  490,  421,  512,  265,  480,  501,  313,  436,  437,
  340,  497,  480,  492,  474,  480,  496,  268,  313,  391,
  500,  268,  513,  340,  414,  513,  507,  420,  396,  513,
  396,  513,  513,  310,  311,  428,  429,  396,  268,  513,
  513,  268,  513,  402,  472,  438,  339,  480,  501,  268,
  480,  487,  268,  430,  514,  507,  513,  507,  507,  477,
  356,  515,  428,  421,  421,  487,  390,  436,  265,  507,
  513,  310,  311,  431,  432,  507,  356,  420,  513,  414,
  340,  414,  435,  507,  507,  512,  356,  515,  431,  420,
  507,  513,  492,  513,  313,  420,  268,  313,  443,  356,
  420,  513,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          1,
   82,  447,  145,  146,  147,  148,  285,   83,  305,  306,
  557,  408,  484,  259,  260,   85,   86,   87,  300,  411,
  572,  616,  617,  634,  654,  655,   88,   89,  663,  589,
  590,  626,  268,  182,  443,  183,  679,   90,   91,  444,
  315,   92,  426,   93,  138,  191,   95,  321,  290,  323,
   96,  291,  264,  266,   97,  206,   98,   99,  100,  101,
  192,  327,  328,  310,  416,  428,  417,  438,  466,  467,
  261,  142,  143,  103,  370,  371,  104,  257,  121,  119,
  177,  309,  581,  421,  495,  496,  576,  422,  497,  498,
  545,  423,  499,  500,  501,    5,    6,    8,  110,  311,
  173,    7,  188,  392,  551,  120,  374,  105,  375,  106,
  518,  307,  178,  559,
};
static const YYINT yysindex[] = {                         0,
 -242,    0,    0,    0,    0,    0, 1203, -233, -198, -185,
 -123,    0,  327,    0,  327,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -200,    0,    0,    0,    0,    0,    0,
    0,  -69,   60, 5386, 6574,    0,    0,    0, -140, 6574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -63,  -60, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574,  -18,    0, 5254,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,    0,
    0,  -87,   62,  -34,  -15,    0, 5088,  127,  142,   87,
    0, -218, 7042,   67, 1339,  122,    0,    0,    0,    0,
 5088, 5088,  128,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  132,   57, -165,    0,    0,    0,    0,    0,
    0, -185, -123,  152,  142,  205,    0,  -46, 2124,    0,
    0,    0,    0, 6638,    0,  136,    0,  159, 6574, 6574,
    0,  866,    0,  866,  866,    0,  866,    0,  866,  866,
  866,  866,  866,    0, 5914,   91,   16,   99,    0, 1475,
   94,    0,    0,    0,  107,    0,  243,  180,    0,  203,
  123,    0,  185,    0, 5088,  216,    0,    0, 6046, 3788,
    0,  -15, -140, 5088, 5088, 5088, 5088, 5088,   25,   94,
  167,    0,    0,    0,    0, 5088,    0,    0, 5386,  131,
 6574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 6574, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574,    0,    0,    0,    0,
    0, 6574,  225,  228, 6574, 6574, 6574, 6574,    0, 1339,
  277,    0,  128,  276,  128,  278,  206,  279,  155, 6574,
  156, 1339,  161,  166,    0,    0,  168,  295, 6574,  295,
    0,    0,    0,    0,  164, 6695, 6752, 6574,   14, -290,
  176, 6809,    0,  254,    0,    0,  182, 1339,    0,    0,
    0,    0,    0,    0,    0,    0,  308,    0,    0,  183,
 5088,  189,    0, 6178,  237,  192,    0,    0,    0,   68,
  198,  251, -172,  201,    0, -253,  207, -162,    0,    0,
    0,    0,    0,  -53,  107,    0,  281, 3999, -200,   94,
  153,    0,    0,  845, 6865, 2237, 2350, 2463, 2576, 2689,
  589,  589,  440,  440,  440,  440,  316,  316,  736,  736,
  845,  845,  845,  845,  211,    0,    0,  214, 2010,  209,
    0, 7042, 7042,  338,    0,    0,    0,  343,    0,  347,
    0,  128,    0,    0,  217, 5386,  314, 5386, 5386, 5386,
    0,  220,    0,  221,    0,    0, 5088,  307,  226,  261,
  227,  241, 6574,  242,  372, 5386,  375,  248,    0,    0,
    0,  300,    0,  339,  167,    0, -135,    0, 5518, 7042,
    0,    0,    0,    0,    0,  152,    0,    0,  -15,  -15,
  383,  -15,  -15,    0,    0,    0, 5088,    0,    0,    0,
    0,    0,  389,  317, -261,  319,  394,    0,    0,    0,
  258, 6574,    0,    0, 6574,    0,    0,    0,  273, 5088,
 5088,    0,  404,  274,  280,  406,  282,  284,  407,    0,
    0,  -37,  286,    0,    0,    0,    0,    0, 6574,    0,
  287,    0, -200,    0, 6574,    0, 5088,    0,    0,  334,
 6178,  -18,  363, 6926,  346,    0,  352,    0,  356,    0,
    0,    0,  303,    0,    0,    0,    0,    0,    0,    0,
  301,    0,  165,    0,  412, -200,    0,  436,    0, 2124,
    0, 5386,    0,    0,    0, 1339, 5386, 5386, 1339,  308,
 5386,    0,    0,  437,  443,  445,  866,    0, 1339,    0,
 1613,    0, 6178, 7042,    0,    0,  400,  374, 6178, 6178,
  446, 6310,  447, -216,  449,    0,    0,  380,  308,    0,
    0,    0,    0,    0,    0, 1339,  325,    0,  326,    0,
    0,    0,  100,  330, 5650,    0,    0, 6442,    0, 5782,
    0,    0,  321,  192,    0, 7042,    0,    0,    0,  408,
 6178,    0, 7042,    0,  460, 6926,    0,    0,  334,  363,
    0,    0,    0, 6574,    0,    0,    0,  465,  308,    0,
    0,    0,    0, 5386,  410,    0,  100, 1339,    0,    0,
    0,    0,    0, 1339,    0,  349,  400, 7042,    0,    0,
 7042,  534,    0,    0,  181,    0,    0,    0,    0,  444,
 1339,    0,    0,    0,    0,  308, -234,    0,    0,    0,
    0,    0,  448,    0,  181,    0, 1339,    0,    0,    0,
 6178,    0,    0,    0,    0,  488, 1339,    0,    0,    0,
    0,    0,    0,  539,  502,    0,    0,    0,  463, 1339,
    0,    0,
};
static const YYINT yyrindex[] = {                         0,
 1067,    0,    0,    0,    0,    0,  219,    0,    0,  515,
  517,    0,    0,    0, 1548,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   77,  532,    0,    0,    0, 1680, -252,
 -149,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  532,  532,  532,
  532,  532,  532,  532,  532,  532,    0,    0,  532,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   31,  328,    0, -267,  528,  891,    0,
    0,  424, -245, -235,   97,    0,    0,    0,    0,    0,
  -57,   17,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  931,    0,    0,  543, 5066,    0,
    0,    0,    0, -176,    0, -173,    0,    0,  532,  532,
    0, 2076,    0, 2190, 2304,    0, 2418,    0, 2532, 2646,
 2760, 2874, 2988,    0,  532,    0, -228,    0,    0,  219,
  765,    0,    0,    0, 1680,    0, -133,   15,    0,    0,
  -52,    0, -220,    0,    0,    0,    0,    0, -250,    0,
    0,  328,    0,    0,    0,    0,    0,    0,    0,   74,
 -265,    0,    0,    0,    0, -267,    0,    0,  532,    0,
  532,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  532,  532,  532,  532,
  532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
  532,  532,  532,  532,  532,  532,    0,    0,    0,    0,
    0,  532,    0,    0,  532, -249,  532,  532,    0,  145,
    0,    0,    0,    0,    0,    0,  -38,    0,    0, -247,
    0,  219,    0,    0,    0,    0,    0,  432,  532,  432,
    0,    0,    0,    0, -244,    0,    0,  -85,  543,    0,
    0,  452,    0,    0,  240,    0,    0,   97,    0,    0,
    0,    0,    0,    0,    0,    0,  497,    0,    0,    0,
 -282,    0,    0,  532,  -55,    0,    0,    0,    0,  543,
    0,  453,    0,    0,    0,  -73,    0,  442,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   74,
    0,    0,    0, 3216,    0, 5043, 4949, 4924, 4828, 4800,
 4602, 4701, 4190, 4293, 4396, 4499, 3980, 4085, 3766, 3873,
 3326, 3436, 3546, 3656,    0,    0,    0,    0,  442,    0,
    0, -211,  -67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  532,    0, -181,  532,   77,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  532, 6985,    0,  532,    0,  469,    0,    0,
    0,    0,    0,    0, -171,    0,  442,    0,  532,   38,
    0,    0,    0,    0,    0,    0,    0,    0,  328,  328,
    0,  328,  328,    0,    0,    0,    0,    0,    0,    0,
    0,  163,    0,  579,    0,  581,    0,    0,    0,    0,
    0,  532,    0,    0,  532,    0,    0,    0,    0,  -57,
   17,    0,    0,    0,    0,  451,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  532,    0,
    0,    0,    0,    0,  532,    0,  535,    0,    0, 1876,
  532,  536, 1746,   30,  218,    0,  583,    0,  583,    0,
    0,    0,    0,  -72,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 5156,
    0,  532,    0,    0,    0,  219,  532, -181,  219,    0,
 -195,    0,    0, 1812,    0, 1944, 3102,    0,  219,    0,
    0,    0,  532, -139,    0,    0,    0,    0,  532,  105,
  588,  135,    0,  591,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   97,    0,    0,    0,    0,
    0,    0,  593,    0,  532,    0,    0,  532,    0,  532,
    0,    0,  614,    0,    0,   11,    0,    0,    0,  467,
  532,    0,   30,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  532,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  532,    0,    0,  593,  219,    0,    0,
    0,    0,    0,  219,    0,    0,    0,   24,    0,    0,
 -182,    0,    0,    0,  594,    0,    0,    0,    0,    0,
  145,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  594,    0,  145,    0,    0,    0,
  532,    0,    0,    0,    0,    0,  145,    0,    0,    0,
    0,    0,    0,    0,  507,    0,    0,    0,    0,  145,
    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
  -19,  350,    0,    0,  584,    0,    0,  -78,    0,    0,
    0,    0,    0, -232,   -3,  697,    0,    0,    0,    0,
    0,  255,    0,    0,  222,    0,    0,  112,    0,  257,
    0,    0, -239,  466, -411,    0,    0,    0,    0,    0,
    0,  -28,    0,  -94,   -7, -156,    0,    0,  689,    0,
    0, -184,  450,  483,  212,    0,    0,   43,    0,  -82,
  434,  474,    0,  519,  462,  368,    0, -359,  -42,  441,
   12,  694,  692,    5,    0,  513,    0,    0,    0,  961,
 -420,    0,    0,   -8,    0, -538,    0,  454,    0,  425,
  430,    0,    0,  429, -279,    0,    0,  -75,    0,   92,
 -166,    0, -160,  707,    7,  187,   21, -508, -326,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 7437
static const YYINT yytable[] = {                         94,
  166,  136,  200,   84,  324,  302,  176,  504,  171,  456,
  301,  594,  208,    2,  124,  134,  263,  265,  102,  205,
   29,  573,  148,  378,  147,  380,  210,  376,    3,  203,
  148,  107,   14,  515,  424,  329,   94,  108,  148,  336,
  148,  148,  176,  148,  125,  148,  208,  147,  400,  139,
  134,  441,  514,  218,  144,  137,  218,  488,  218,  434,
  151,  153,  147,  156,  158,  407,  278,  365,  111,  280,
  368,  167,  152,  154,  155,  157,  159,  160,  161,  162,
  163,  112,  215,  202,   13,  215,  135,  215,  210,  201,
  168,   28,  205,  205,   29,  148,  599,   94,  198,  401,
  635,  562,  203,  201,  201,  661,  172,  436,  185,  148,
  205,  340,   47,  194,   49,   26,  185,  125,  125,  209,
  203,  135,  673,  218,  123,  480,  218,  218,  335,  126,
  127,  128,  129,   87,  436,  125,  148,  140,  147,  163,
  412,  147,  462,  113,  218,  125,  212,   47,  208,  175,
  205,  208,  215,  286,  287,  215,  215,  289,  205,   29,
  203,    4,   94,   34,   34,   34,  431,  198,  203,  292,
  109,  169,  170,  215,  600,  125,  437,  317,  218,  448,
  134,  320,  326,  125,  218,  632,  330,  331,  332,  333,
  334,  595,  218,  292,  216,  130,  191,  206,  201,  335,
  202,   94,  180,  487,  646,  148,   87,  215,  199,  116,
  171,  546,  117,  215,  202,  344,  414,  432,  478,  210,
  342,  215,  199,  199,  198,  181,  110,  210,  410,  110,
   28,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  135,   94,  165,   26,  148,  292,  141,  450,  292,
  369,  372,  373,  587,   94,  191,  451,    9,  387,  546,
  206,  206,  505,  506,  144,  508,  509,  179,  340,   96,
  156,   96,  116,  144,  173,  117,  117,  117,  206,  642,
   94,  342,  157,  337,  338,  339,  199,  325,  341,  325,
  116,  199,  123,  415,  165,  199,  199,  199,  199,  199,
  205,  629,  271,  272,  273,  274,  185,  199,  420,  446,
   13,  147,  191,  185,  131,  409,  277,  668,  206,  148,
  445,  149,  185,  608,  150,  185,  206,  558,  174,  335,
  116,  202,  439,   13,  186,  561,  205,  469,  116,  340,
  565,  117,  184,  377,   96,  297,  186,  134,  532,  134,
  134,  134,  342,   13,   51,  263,  265,  148,  325,  187,
  316,  164,   16,  189,   16,  123,  123,  134,   94,  190,
   94,   94,   94,  185,  207,  185,   13,  148,  181,  472,
  181,  181,  414,  123,  181,  148,  607,  464,   94,  137,
  468,  137,   16,  399,  186,  258,  294,  292,  658,  614,
  615,  295,   51,   16,   17,   18,   19,  481,  202,  187,
  203,  204,  199,  494,  670,  148,  262,  113,  135,  326,
  135,  135,  135,  123,  676,  148,  181,  185,  181,  181,
  267,  123,  181,  636,  269,  638,  639,  681,  135,  199,
  125,  270,  201,  201,   51,   51,  520,  429,  186,  369,
   47,  174,  175,  540,  275,   47,  650,  449,   81,  276,
  656,  282,  283,  284,  281,   36,   36,  441,  514,  415,
  605,  405,  664,  537,  665,   17,  293,   17,  574,  541,
  652,  653,  671,  134,  296,  544,  446,  187,  134,  134,
  538,  113,  134,  553,  303,  555,   45,  304,  199,  148,
  181,  308,  181,  181,   94,  312,  181,  313,   94,   94,
   94,   94,  568,   94,  314,  571,  579,  582,  318,  145,
  145,   94,   36,  567,  343,  583,  185,  366,  569,  137,
  367,  208,  137,  379,  382,  381,  383,  586,  199,  384,
  386,   36,  145,  544,  593,  388,  596,   36,   94,  391,
  389,  396,  390,  459,  135,  402,  404,  660,  662,  135,
  135,  199,  199,  135,   14,  425,  406,  603,  413,  596,
  606,  211,  593,  418,  593,  134,  427,  430,  610,  400,
  433,  612,  613,  440,  125,  628,  620,  134,  199,  621,
  453,  623,  435,  454,  457,  458,   94,  460,  631,  145,
   94,  461,  463,   52,  644,  465,   94,  134,  134,  473,
  645,  474,  476,  470,  471,  640,  511,  125,  145,  145,
  145,  637,  475,   94,  145,  145,  477,  479,  419,  485,
  134,  134,  482,  145,  114,  115,  116,  117,  118,   94,
  483,  486,  507,  512,  651,  513,  135,  516,  517,   94,
  534,  519,  535,  536,  659,  593,  134,  522,  525,  526,
  528,  531,   94,  543,  527,  548,  563,  529,  547,  530,
  672,  533,  539,  674,  550,  241,  242,  243,  244,  245,
  552,  246,  247,  248,  554,  190,  249,  134,  556,  250,
  251,  682,  566,  575,  252,  211,  253,  254,  255,  578,
  256,  580,  588,  591,  598,  436,  602,  134,  134,  604,
  609,  611,  624,  134,   81,  618,  584,  630,   81,   81,
   81,  134,  633,   81,   81,   81,   81,   81,  647,   81,
   81,   81,   81,   81,   81,   81,  627,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   13,  641,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,  649,  657,
  675,   81,   81,  667,   81,   81,  677,  239,  240,  241,
  242,  243,  244,  245,  678,  246,  247,  248,  680,   91,
  249,   92,  148,  250,  251,  184,   81,   10,  252,   81,
  253,  254,  255,  147,  256,   15,    9,  200,  666,   81,
   81,  169,  162,  112,   81,   39,   78,  148,   45,   81,
   17,   81,   81,   81,  211,  200,  320,   81,   16,   81,
   99,  104,  108,   81,  395,  564,  299,   81,   81,   52,
   81,  643,   81,   52,   52,   52,  669,  322,   52,   52,
   52,   52,   52,  648,   52,   52,   52,   52,   52,   52,
   52,  502,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,  523,
  510,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,  524,  560,  503,   52,   52,  542,   52,
   52,  625,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,  385,  246,  247,  248,  521,  570,  249,
  393,   52,  250,  251,   52,  122,  597,  252,  592,  253,
  254,  255,  601,  256,   52,   52,  394,  577,    0,   52,
    0,    0,    0,    0,   52,    0,   52,   52,   52,    0,
    0,  211,   52,    0,   52,    0,    0,    0,   52,    0,
    0,    0,   52,   52,    0,    0,   52,   52,    0,    0,
   13,    0,    0,    0,   13,   13,   13,    0,    0,   13,
   13,   13,    0,   13,    0,   13,   13,   13,   13,   13,
   13,   13,    0,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
    0,    0,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,    0,    0,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,    0,    0,    0,   13,   13,    0,
   13,   13,    0,    0,    0,    0,    0,  243,  244,  245,
    0,  246,  247,  248,    0,    0,  249,    0,    0,  250,
  251,    0,   13,    0,  252,   13,  253,  254,  255,    0,
  256,    0,    0,    0,    0,   13,   13,    0,    0,    0,
   13,    0,    0,    0,    0,   13,    0,   13,   13,   13,
  175,  175,  175,   13,    0,   13,    0,    0,    0,   13,
    0,    0,    0,   13,   13,    0,  175,  175,    0,  175,
  175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
  175,    0,  180,    0,  180,  180,    0,    0,  180,    0,
  175,  175,  175,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  175,  175,  175,  175,  175,    0,  175,
  175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
  246,  247,  248,    0,    0,  249,    0,    0,  250,  251,
    0,    0,    0,  252,    0,  253,  254,  255,    0,  256,
    0,    0,    0,  175,  175,  175,  249,    0,  175,  250,
  251,  175,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,  175,    0,    0,    0,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,    0,  175,    0,
    0,  175,    0,    0,  175,    0,    0,    0,    0,    0,
    0,    0,  175,    0,    0,    0,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,   11,   11,   11,    0,
    0,   11,   11,   11,  175,   11,    0,    0,   11,   11,
   11,   11,   11,   11,    0,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,    0,    0,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,    0,    0,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,    0,    0,    0,   11,
   11,    0,   11,   11,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   11,    0,    0,   11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   11,   11,    0,
    0,    0,   11,    0,    0,    0,    0,   11,    0,   11,
   11,   11,    0,    0,    0,   11,    0,   11,    0,    0,
    0,   11,    9,   10,   11,   11,   11,   12,   13,   14,
    0,   15,    0,    0,   16,   17,   18,   19,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,    0,    0,   34,    0,    0,    0,    0,
    0,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,    0,    0,   46,   47,   48,   49,   50,   51,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,   66,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,    0,    0,   69,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   70,   71,    0,    0,    0,   72,    0,
    0,    0,    0,   73,    0,   74,   75,   76,    0,    0,
    0,   77,    0,   78,    0,    0,    0,   79,    9,   10,
   11,   80,   81,   12,   13,   14,    0,   15,    0,    0,
   16,   17,   18,   19,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   33,    0,
    0,   34,    0,    0,    0,    0,    0,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,   45,    0,    0,
   46,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,    0,   66,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,    0,    0,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   70,
   71,    0,    0,    0,   72,    0,    0,    0,    0,   73,
    0,   74,   75,   76,    0,    0,    0,   77,    0,   78,
    0,    0,    0,   79,    9,   10,   11,   80,   81,   12,
   13,  298,    0,   15,    0,    0,   16,   17,   18,   19,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,    0,    0,   34,    0,    0,
    0,    0,    0,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,    0,    0,   46,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,    0,
   66,   67,  291,  291,    0,  291,    0,  291,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,    0,    0,   69,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   70,   71,    0,    0,    0,
   72,    0,    0,    0,    0,   73,    0,   74,   75,   76,
    0,    0,    0,   77,    0,   78,    0,    0,    0,   79,
    0,    0,    0,   80,   81,    0,    0,  585,  211,    0,
    0,    0,  291,    0,    0,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,    0,  291,  291,  291,    0,    0,  291,    0,
    0,  291,  291,    0,    0,    0,  291,  291,  291,  291,
  291,    0,  291,  291,   44,   44,    0,   44,    0,   44,
    0,  291,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,    0,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
  239,  240,  241,  242,  243,  244,  245,    0,  246,  247,
  248,    0,    0,  249,    0,    0,  250,  251,    0,    0,
    0,  252,    0,  253,  254,  255,    0,  256,    0,    0,
    0,  280,    0,  280,   44,  280,    0,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,    0,   44,   44,   44,    0,    0,
   44,    0,    0,   44,   44,    0,    0,    0,   44,   44,
   44,   44,   44,    0,   44,   44,  329,  329,    0,  329,
  280,  329,    0,   44,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,    0,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
    0,  280,  280,  280,    0,    0,  280,    0,    0,  280,
  280,    0,    0,    0,  280,    0,  280,  280,  280,    0,
  280,   43,    0,   43,    0,   43,  329,    0,    0,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,    0,  329,  329,  329,
    0,    0,  329,    0,    0,  329,  329,    0,    0,    0,
  329,  329,  329,  329,  329,    0,  329,  329,  314,  314,
   43,  314,    0,  314,   43,  329,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,    0,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
    0,   43,   43,   43,    0,    0,   43,    0,    0,   43,
   43,    0,    0,    0,   43,    0,   43,   43,   43,    0,
   43,    0,    0,    0,    0,  211,    0,    0,  314,  436,
    0,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,    0,  314,
  314,  314,    0,    0,  314,    0,    0,  314,  314,    0,
    0,    0,  314,  314,  314,  314,  314,    0,  314,  314,
  224,  224,    0,  224,    0,  224,    0,  314,  455,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,    0,  228,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,    0,  246,  247,  248,    0,  211,
  249,    0,    0,  250,  251,    0,    0,    0,  252,    0,
  253,  254,  255,    0,  256,    0,    0,    0,    0,    0,
  224,    0,    0,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
    0,  224,  224,  224,  223,  223,    0,  223,    0,  223,
    0,    0,    0,    0,    0,  224,    0,    0,    0,    0,
    0,  224,    0,    0,    0,    0,    0,    0,  227,  224,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,  240,  241,  242,  243,  244,  245,    0,  246,
  247,  248,  211,    0,  249,    0,    0,  250,  251,    0,
    0,    0,  252,    0,  253,  254,  255,    0,  256,    0,
    0,    0,    0,    0,  223,    0,    0,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,    0,  223,  223,  223,  225,  225,
    0,  225,    0,  225,    0,    0,    0,    0,    0,  223,
    0,    0,    0,    0,    0,  223,    0,    0,    0,    0,
    0,    0,    0,  223,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
  245,    0,  246,  247,  248,  211,    0,  249,    0,    0,
  250,  251,    0,    0,    0,  252,    0,  253,  254,  255,
    0,  256,    0,    0,    0,    0,    0,    0,  225,    0,
    0,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,    0,  225,
  225,  225,  221,  221,    0,  221,    0,  221,    0,    0,
    0,    0,    0,  225,    0,    0,    0,    0,    0,  225,
    0,    0,    0,    0,    0,    0,    0,  225,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,    0,  246,  247,  248,  211,    0,
  249,    0,    0,  250,  251,    0,    0,    0,  252,    0,
  253,  254,  255,    0,  256,    0,    0,    0,    0,    0,
    0,    0,  221,    0,    0,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,    0,  221,  221,  221,  222,  222,    0,  222,
    0,  222,    0,    0,    0,    0,    0,  221,    0,    0,
    0,    0,    0,  221,    0,    0,    0,    0,    0,    0,
    0,  221,  231,  232,  233,  234,  235,  236,  237,  238,
  239,  240,  241,  242,  243,  244,  245,    0,  246,  247,
  248,  211,    0,  249,    0,    0,  250,  251,    0,    0,
    0,  252,    0,  253,  254,  255,    0,  256,    0,    0,
    0,    0,    0,    0,    0,    0,  222,    0,    0,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,    0,  222,  222,  222,
  227,  227,    0,  227,    0,  227,    0,    0,    0,    0,
    0,  222,    0,    0,    0,    0,    0,  222,    0,    0,
    0,    0,    0,    0,    0,  222,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
    0,  246,  247,  248,  211,    0,  249,    0,    0,  250,
  251,    0,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  227,    0,    0,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
    0,  227,  227,  227,  226,  226,    0,  226,    0,  226,
    0,    0,    0,    0,    0,  227,    0,    0,    0,    0,
    0,  227,    0,    0,    0,    0,    0,    0,    0,  227,
  233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,    0,  246,  247,  248,    0,    0,  249,
    0,    0,  250,  251,    0,    0,    0,  252,    0,  253,
  254,  255,    0,  256,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  226,    0,    0,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,    0,  226,  226,  226,  229,  229,
    0,  229,    0,  229,    0,    0,    0,    0,    0,  226,
    0,    0,    0,    0,    0,  226,    0,    0,    0,    0,
    0,    0,    0,  226,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  229,    0,
    0,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,    0,  229,
  229,  229,  231,  231,    0,  231,    0,  231,    0,    0,
    0,    0,    0,  229,    0,    0,    0,    0,    0,  229,
    0,    0,    0,    0,    0,    0,    0,  229,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  231,    0,    0,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,    0,  231,  231,  231,  278,  278,    0,  278,
    0,  278,    0,    0,    0,    0,    0,  231,    0,    0,
    0,    0,    0,  231,    0,    0,    0,    0,    0,    0,
    0,  231,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  278,    0,    0,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,    0,  278,  278,  278,
  239,  239,    0,  239,    0,  239,    0,    0,    0,    0,
    0,  278,    0,    0,    0,    0,    0,  278,    0,    0,
    0,    0,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  239,    0,    0,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  236,  236,    0,  236,    0,  236,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  239,    0,    0,    0,    0,
    0,  239,    0,    0,    0,    0,    0,    0,    0,  239,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  236,    0,    0,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  237,  237,    0,  237,    0,  237,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  236,    0,    0,    0,    0,
    0,  236,    0,    0,    0,    0,    0,    0,    0,  236,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  237,    0,    0,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  238,  238,    0,  238,    0,  238,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  237,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,    0,    0,  237,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  238,    0,    0,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  240,  240,    0,  240,    0,  240,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  238,    0,    0,    0,    0,
    0,  238,    0,    0,    0,    0,    0,    0,    0,  238,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  240,    0,    0,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  234,    0,    0,  234,    0,  234,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  240,    0,    9,  132,  133,
    0,  240,    0,    0,    0,    0,    0,    0,    0,  240,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  234,   48,  193,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  235,    0,    0,
  235,    0,  235,    0,    0,  194,    0,    0,  195,    0,
    0,    0,    0,    0,    0,  234,    0,    0,    0,  196,
    0,  234,    0,  197,    0,    0,    0,    0,    0,  234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  198,  325,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  235,    0,    0,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  243,    0,    0,  243,    0,  243,
    0,    0,    0,    0,    0,    0,    0,    0,    9,  132,
  133,    0,  235,    0,    0,    0,    0,    0,  235,    0,
    0,    0,    0,    0,   20,   21,  235,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  441,  442,  193,  243,    0,    0,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  244,
    0,    0,  244,    0,  244,    0,  194,    0,    0,  195,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  243,
  196,    0,    0,    0,  197,  243,    0,    0,    0,    0,
    0,    0,    0,  243,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  198,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  244,
    0,    0,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  253,    0,    0,  253,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  244,    0,    0,    0,    0,    0,
  244,    0,    0,    0,    0,    0,    0,    0,  244,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  253,    0,    0,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  254,    0,    0,
  254,    0,  254,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,    0,    0,    0,  253,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  254,    0,    0,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  255,    0,    0,  255,    0,  255,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  254,    0,    0,    0,    0,    0,  254,    0,
    0,    0,    0,    0,    0,    0,  254,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  255,    0,    0,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  256,    0,    0,  256,    0,  256,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  255,    0,    0,    0,    0,
    0,  255,    0,    0,    0,    0,    0,    0,    0,  255,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  256,    0,    0,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  251,    0,    0,  251,
    0,  251,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  256,    0,
    0,    0,    0,    0,  256,    0,    0,    0,    0,    0,
    0,    0,  256,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  251,    0,    0,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  252,    0,    0,  252,    0,
  252,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  251,    0,    0,    0,    0,    0,  251,    0,    0,
    0,    0,    0,    0,    0,  251,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  252,    0,    0,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  247,    0,    0,  247,    0,  247,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  252,    0,  246,    0,    0,  246,  252,  246,    0,    0,
    0,    0,    0,    0,  252,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  247,    0,    0,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,    0,  246,    0,    0,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  248,  247,
    0,  248,    0,  248,    0,  247,    0,    0,    0,    0,
    0,    0,    0,  247,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  249,    0,    0,  249,  246,  249,    0,
    0,    0,    0,  246,    0,    0,    0,    0,    0,    0,
    0,  246,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  248,    0,
    0,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  249,    0,    0,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  250,    0,    0,
  250,    0,  250,  248,    0,    0,    0,    0,    0,  248,
    0,    0,    0,    0,    0,    0,    0,  248,    0,    0,
  233,    0,    0,  233,    0,  233,    0,    0,  249,    0,
    0,    0,    0,    0,  249,    0,    0,    9,  132,  133,
    0,    0,  249,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,  250,    0,    0,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  233,   48,  193,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  245,  233,    0,  245,    0,  245,    0,    0,    0,    0,
    0,    0,  250,    0,    0,    0,    0,    0,  250,    0,
    0,    0,    0,    0,    0,  194,  250,    0,  195,    0,
    0,    0,    0,    0,    0,  233,    0,    0,    0,  196,
    0,  233,    0,  197,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  198,    0,    0,    0,    0,    0,    0,    0,
  245,    0,    0,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
    0,  245,    0,    9,  132,  133,    0,    0,    0,   13,
   14,    0,   15,    0,    0,   16,   17,   18,   19,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,  245,    0,    0,    0,    0,
    0,  245,   35,   36,    0,    0,    0,    0,    0,  245,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,   71,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
    0,    0,  165,    0,   78,    9,  132,  133,   79,    0,
    0,   13,    0,    0,   15,    0,    0,   16,   17,   18,
   19,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   35,   36,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
    0,   66,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,    0,    0,   69,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,   71,    0,    0,
    0,   72,    0,    0,    0,    0,   73,    0,   74,   75,
   76,    0,    0,    0,   77,    0,   78,    9,  132,  133,
   79,    0,    0,   13,  419,  489,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
  490,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,  491,   66,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,    0,    0,   69,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   70,   71,
    0,    0,    0,   72,    0,    0,    0,    0,   73,    0,
   74,   75,   76,    0,    0,    0,  492,    0,  493,    9,
  132,  133,   79,    0,    0,   13,    0,  619,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  491,   66,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
   69,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   70,   71,    0,    0,    0,   72,    0,    0,    0,    0,
   73,    0,   74,   75,   76,    0,    0,    0,   77,    0,
   78,    9,  132,  133,   79,    0,    0,   13,  419,  622,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,   66,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
    0,    0,   69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,    0,    0,    0,   72,    0,    0,
    0,    0,   73,    0,   74,   75,   76,    0,    0,    0,
  492,    0,   78,    9,  132,  133,   79,    0,    0,   13,
    0,    0,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,  288,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
    0,    0,   77,  164,   78,    9,  132,  133,   79,    0,
    0,   13,    0,    0,   15,  319,    0,    0,    0,    0,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
    0,   66,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,    0,    0,   69,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,  288,    0,    0,
    0,   72,    0,    0,    0,    0,   73,    0,   74,   75,
   76,    0,    0,    0,   77,    0,   78,    9,  132,  133,
   79,    0,    0,   13,  419,    0,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
   47,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,    0,   66,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,    0,    0,   69,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   70,   71,
    0,    0,    0,   72,    0,    0,    0,    0,   73,    0,
   74,   75,   76,    0,    0,    0,   77,    0,   78,    9,
  132,  133,   79,    0,    0,   13,    0,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  491,   66,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
   69,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   70,   71,    0,    0,    0,   72,    0,    0,    0,    0,
   73,    0,   74,   75,   76,    0,    0,    0,   77,    0,
   78,    9,  132,  133,   79,    0,    0,   13,  419,    0,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,   66,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
    0,    0,   69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,    0,    0,    0,   72,    0,    0,
    0,    0,   73,    0,   74,   75,   76,    0,    0,    0,
  492,    0,   78,    9,  132,  133,   79,    0,    0,   13,
    0,    0,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,  211,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,   71,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
  211,    0,   77,    0,   78,    0,    0,    0,   79,    0,
    0,    0,    0,    0,    0,    0,  279,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,    0,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
  244,  245,    0,  246,  247,  248,    0,  211,  249,    0,
    0,  250,  251,    0,    0,    0,  252,    0,  253,  254,
  255,    0,  256,  397,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
    0,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,  242,  243,  244,  245,    0,
  246,  247,  248,    0,  211,  249,    0,    0,  250,  251,
    0,    0,    0,  252,    0,  253,  254,  255,    0,  256,
  398,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,    0,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,  242,  243,  244,  245,    0,  246,  247,  248,
  211,    0,  249,    0,    0,  250,  251,    0,    0,    0,
  252,    0,  253,  254,  255,    0,  256,  403,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,    0,  228,  229,  230,  231,  232,
  233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,    0,  246,  247,  248,    0,    0,  249,
    0,  211,  250,  251,    0,    0,    0,  252,    0,  253,
  254,  255,    0,  256,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  452,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,  242,  243,  244,  245,    0,
  246,  247,  248,    0,    0,  249,    0,    0,  250,  251,
  277,    0,    0,  252,    0,  253,  254,  255,    0,  256,
  549,    0,    0,    0,    0,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,    0,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
    0,  246,  247,  248,    0,    0,  249,  211,    0,  250,
  251,    0,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,    0,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
    0,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,    0,
  277,  277,  277,    0,    0,  277,    0,    0,  277,  277,
    0,    0,    0,  277,    0,  277,  277,  277,    0,  277,
    0,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,    0,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,  242,  243,  244,  245,    0,  246,  247,  248,
    0,    0,  249,    0,    0,  250,  251,    0,    0,    0,
  252,    0,  253,  254,  255,    0,  256,
};
static const YYINT yycheck[] = {                          7,
   79,   44,   97,    7,  189,  172,   89,  428,   84,  369,
  171,  550,  265,  256,   34,   44,  111,  112,    7,  265,
  265,  530,  290,  263,  290,  265,  102,  260,  271,  265,
  313,  265,  267,  445,  314,  192,   44,  271,  291,  200,
  291,  291,  125,  291,  265,  313,  265,  313,  339,   45,
   79,  313,  314,  265,   50,   44,  268,  417,  270,  313,
   68,   69,  291,   71,   72,  298,  142,  252,  267,  145,
  255,   79,   68,   69,   70,   71,   72,   73,   74,   75,
   76,  267,  265,  265,  313,  268,   44,  270,  265,   97,
   79,  265,  338,  339,  339,  291,  313,  105,  270,  390,
  609,  513,  338,  111,  112,  340,   86,  270,  370,  291,
  356,  206,  313,  396,  315,  265,  370,  338,  339,  338,
  356,   79,  661,  335,   33,  405,  338,  339,  268,   38,
   39,   40,   41,  267,  270,  356,  404,   46,  404,  390,
  307,  313,  382,  267,  356,   34,  396,  313,  396,  315,
  396,  404,  335,  149,  150,  338,  339,  165,  404,  404,
  396,  404,  170,  313,  314,  315,  339,  339,  404,  165,
  404,   80,   81,  356,  391,  396,  339,  185,  390,  340,
  209,  189,  190,  404,  396,  606,  194,  195,  196,  197,
  198,  551,  404,  189,  267,  265,  270,  265,  206,  339,
  396,  209,  290,  339,  625,  291,  340,  390,   97,  265,
  268,  491,  265,  396,  396,  211,  311,  390,  403,  396,
  209,  404,  111,  112,  396,  313,  265,  404,  307,  268,
  404,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
  246,  209,  260,  339,  404,  313,  252,  398,  341,  255,
  256,  257,  258,  543,  272,  339,  342,  340,  272,  549,
  338,  339,  429,  430,  270,  432,  433,   91,  268,  265,
  288,  267,  338,  279,  268,  338,  339,  340,  356,  616,
  298,  268,  288,  202,  203,  204,  185,  268,  207,  270,
  356,  190,  265,  311,  390,  194,  195,  196,  197,  198,
   99,  591,  126,  127,  128,  129,  370,  206,  314,  339,
  290,  291,  396,  370,  265,  305,  140,  654,  396,  313,
  338,  395,  370,  566,  395,  370,  404,  504,  314,  315,
  396,  265,  396,  313,  391,  512,  135,  390,  404,  339,
  517,  404,  291,  262,  340,  169,  391,  386,  396,  388,
  389,  390,  339,  290,  268,  460,  461,  291,  339,  404,
  184,  390,  268,  389,  270,  338,  339,  406,  386,  395,
  388,  389,  390,  370,  298,  370,  313,  291,  292,  397,
  294,  295,  487,  356,  298,  291,  563,  386,  406,  388,
  389,  390,  268,  390,  391,  339,  391,  403,  641,  310,
  311,  396,  268,  272,  273,  274,  275,  406,  292,  404,
  294,  295,  311,  419,  657,  291,  305,  265,  386,  437,
  388,  389,  390,  396,  667,  291,  292,  370,  294,  295,
  313,  404,  298,  610,  313,  612,  613,  680,  406,  338,
  339,  395,  460,  461,  310,  311,  452,  390,  391,  455,
  313,  314,  315,  483,  313,  313,  633,  315,    0,  265,
  637,  313,  314,  315,  339,  313,  314,  313,  314,  487,
  559,  295,  649,  479,  651,  268,  396,  270,  531,  485,
  310,  311,  659,  522,  396,  491,  516,  404,  527,  528,
  480,  339,  531,  497,  398,  499,  267,  265,  397,  291,
  292,  332,  294,  295,  522,  313,  298,  395,  526,  527,
  528,  529,  526,  531,  340,  529,  535,  536,  313,  290,
  291,  539,  370,  522,  404,  539,  370,  313,  527,  528,
  313,  265,  531,  268,  339,  268,  268,  543,  437,  395,
  395,  389,  313,  549,  550,  395,  552,  395,  566,  265,
  395,  398,  395,  377,  522,  390,  313,  646,  647,  527,
  528,  460,  461,  531,  267,  339,  395,  557,  396,  575,
  560,  266,  578,  395,  580,  614,  395,  390,  568,  339,
  390,  571,  572,  313,  483,  591,  576,  270,  487,  579,
  390,  581,  396,  390,  396,  268,  614,  265,  604,  370,
  618,  265,  396,    0,  618,  302,  624,  290,  291,  313,
  624,  396,  396,  404,  404,  614,  440,  516,  389,  390,
  391,  611,  372,  641,  395,  396,  396,  396,  267,  340,
  313,  314,  268,  404,  318,  319,  320,  321,  322,  657,
  403,  313,  270,  265,  634,  339,  614,  339,  265,  667,
  474,  404,  476,  477,  644,  661,  339,  395,  265,  396,
  265,  265,  680,  340,  395,  313,  265,  396,  492,  396,
  660,  396,  396,  663,  339,  370,  371,  372,  373,  374,
  339,  376,  377,  378,  339,  395,  381,  370,  396,  384,
  385,  681,  267,  267,  389,  266,  391,  392,  393,  267,
  395,  267,  313,  340,  268,  270,  268,  390,  391,  340,
  396,  396,  402,  396,  256,  396,  540,  268,  260,  261,
  262,  404,  268,  265,  266,  267,  268,  269,  390,  271,
  272,  273,  274,  275,  276,  277,  339,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,    0,  356,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  265,  356,
  313,  333,  334,  356,  336,  337,  268,  368,  369,  370,
  371,  372,  373,  374,  313,  376,  377,  378,  356,  305,
  381,  305,  291,  384,  385,  298,  358,  404,  389,  361,
  391,  392,  393,  291,  395,  404,  340,  396,  652,  371,
  372,  390,  390,  265,  376,  265,  396,  313,  313,  381,
  268,  383,  384,  385,  266,  268,  390,  389,  268,  391,
  268,  268,  356,  395,  281,  516,  170,  399,  400,  256,
  402,  617,  404,  260,  261,  262,  655,  189,  265,  266,
  267,  268,  269,  627,  271,  272,  273,  274,  275,  276,
  277,  426,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  460,
  437,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  461,  511,  427,  333,  334,  487,  336,
  337,  584,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,  270,  376,  377,  378,  455,  528,  381,
  279,  358,  384,  385,  361,   15,  552,  389,  549,  391,
  392,  393,  554,  395,  371,  372,  280,  534,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,  266,  389,   -1,  391,   -1,   -1,   -1,  395,   -1,
   -1,   -1,  399,  400,   -1,   -1,  403,  404,   -1,   -1,
  256,   -1,   -1,   -1,  260,  261,  262,   -1,   -1,  265,
  266,  267,   -1,  269,   -1,  271,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
   -1,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,   -1,   -1,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
  336,  337,   -1,   -1,   -1,   -1,   -1,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,  358,   -1,  389,  361,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,
  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,
  260,  261,  262,  389,   -1,  391,   -1,   -1,   -1,  395,
   -1,   -1,   -1,  399,  400,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,  292,   -1,  294,  295,   -1,   -1,  298,   -1,
  260,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  313,  314,  315,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
   -1,   -1,   -1,  313,  314,  315,  381,   -1,  358,  384,
  385,  361,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  395,   -1,   -1,  358,   -1,
   -1,  361,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  395,  260,  261,  262,   -1,
   -1,  265,  266,  267,  404,  269,   -1,   -1,  272,  273,
  274,  275,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,   -1,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,   -1,   -1,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,
   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,
  384,  385,   -1,   -1,   -1,  389,   -1,  391,   -1,   -1,
   -1,  395,  260,  261,  262,  399,  400,  265,  266,  267,
   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,   -1,  293,   -1,   -1,   -1,   -1,
   -1,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,   -1,   -1,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,
   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,   -1,   -1,   -1,  395,  260,  261,
  262,  399,  400,  265,  266,  267,   -1,  269,   -1,   -1,
  272,  273,  274,  275,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,  293,   -1,   -1,   -1,   -1,   -1,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,   -1,   -1,
  312,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,   -1,  336,  337,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,
  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,
   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
   -1,   -1,   -1,  395,  260,  261,  262,  399,  400,  265,
  266,  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,   -1,  293,   -1,   -1,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,   -1,   -1,  312,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
  336,  337,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,
  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,   -1,   -1,   -1,  395,
   -1,   -1,   -1,  399,  400,   -1,   -1,  265,  266,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,   -1,
   -1,  384,  385,   -1,   -1,   -1,  389,  390,  391,  392,
  393,   -1,  395,  396,  265,  266,   -1,  268,   -1,  270,
   -1,  404,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,   -1,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,   -1,  376,  377,
  378,   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,   -1,
   -1,  266,   -1,  268,  335,  270,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,  390,
  391,  392,  393,   -1,  395,  396,  265,  266,   -1,  268,
  335,  270,   -1,  404,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,  266,   -1,  268,   -1,  270,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,  390,  391,  392,  393,   -1,  395,  396,  265,  266,
  335,  268,   -1,  270,  339,  404,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,  266,   -1,   -1,  335,  270,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,   -1,
   -1,   -1,  389,  390,  391,  392,  393,   -1,  395,  396,
  265,  266,   -1,  268,   -1,  270,   -1,  404,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,   -1,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,   -1,  266,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,  355,  404,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  266,   -1,  381,   -1,   -1,  384,  385,   -1,
   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  374,   -1,  376,  377,  378,  266,   -1,  381,   -1,   -1,
  384,  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,
   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  266,   -1,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,   -1,  376,  377,
  378,  266,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  266,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,
   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,  260,  261,  262,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  314,  315,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,  372,
   -1,  396,   -1,  376,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  395,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,
  262,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,  276,  277,  404,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  313,  314,  315,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  265,
   -1,   -1,  268,   -1,  270,   -1,  358,   -1,   -1,  361,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
  372,   -1,   -1,   -1,  376,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,
  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  265,   -1,   -1,  268,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  265,   -1,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,   -1,
   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  390,   -1,  265,   -1,   -1,  268,  396,  270,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  265,  390,
   -1,  268,   -1,  270,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,  268,  390,  270,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  335,   -1,   -1,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  265,   -1,   -1,
  268,   -1,  270,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,  390,   -1,
   -1,   -1,   -1,   -1,  396,   -1,   -1,  260,  261,  262,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  335,  314,  315,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  265,  356,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,   -1,  358,  404,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,  372,
   -1,  396,   -1,  376,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
   -1,  356,   -1,  260,  261,  262,   -1,   -1,   -1,  266,
  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,  299,  300,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,   -1,  389,   -1,  391,  260,  261,  262,  395,   -1,
   -1,  266,   -1,   -1,  269,   -1,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,  300,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,
  315,   -1,   -1,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,
   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  260,  261,  262,
  395,   -1,   -1,  266,  267,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,
  313,  314,  315,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,  335,  336,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,
   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,
  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  260,
  261,  262,  395,   -1,   -1,  266,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,  336,  337,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,
  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,
  381,   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  260,  261,  262,  395,   -1,   -1,  266,  267,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,
   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,   -1,
   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  260,  261,  262,  395,   -1,   -1,  266,
   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,   -1,  389,  390,  391,  260,  261,  262,  395,   -1,
   -1,  266,   -1,   -1,  269,  270,   -1,   -1,   -1,   -1,
   -1,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,
  315,   -1,   -1,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,
   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  260,  261,  262,
  395,   -1,   -1,  266,  267,   -1,  269,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,
  313,  314,  315,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,
   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,
  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  260,
  261,  262,  395,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,  336,  337,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,
  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,
  381,   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  260,  261,  262,  395,   -1,   -1,  266,  267,   -1,
  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,
   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,   -1,
   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  260,  261,  262,  395,   -1,   -1,  266,
   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  266,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
  266,   -1,  389,   -1,  391,   -1,   -1,   -1,  395,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,   -1,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,   -1,  266,  381,   -1,
   -1,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  392,
  393,   -1,  395,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
   -1,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,  266,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,   -1,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  266,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  392,  393,   -1,  395,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,   -1,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,
   -1,  266,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
  392,  393,   -1,  395,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
  266,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
  335,   -1,   -1,   -1,   -1,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,  266,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
   -1,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
   -1,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,   -1,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  392,  393,   -1,  395,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 404
#define YYUNDFTOKEN 521
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL",
"RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE","CONTINUATION",
"THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT",
"NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TWIXT","NAME",
"TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM","OCTAL0_NUM",
"OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT","OCTAL_FLOAT",
"BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST","POLY_CONST",
"THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL","DARROW","ISTYPE",
"HASMEMBER","POUND","COMMA","ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES",
"ASSIGNDIVIDE","ASSIGNDIV","ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL",
"ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND","ASSIGNLOR","ASSIGNOR","ASSIGNAND",
"QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT","LE","GE",
"SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW","STARSTAR","POW2",
"POW3","UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC","STAR","AMPER",
"THREADID","OS","CS","DOT","ARROW","STAROS","CALL","OP","CP","POINTER",
"COLONCOLON","IF","TRY","NONL","ELSE","CATCH","NL","$accept","lines","fullname",
"fullnames","opt_rawnames","rawname","rawnames","rawnamespace","rawatom",
"block","opt_func_body","func_body","func_right","catches","catch","statements",
"statement","simple_statement","if_statement","try_statement",
"try_body_statement","block_or_expr","case_block","cases","case",
"union_case_block","union_cases","union_case","fulltype","namespace",
"comprehension","compnames","compname","comparray","atoms","initnames",
"typenames","name","opt_name","func_decl","func_name","typename","opt_init",
"decl","next_decl","opt_type","type","subscripts","subtype","opt_stars","stars",
"dotdotdots","basetype","dims","struct_members","union_members","class",
"opt_class","opt_publish","publish","publish_extend","namespacename",
"opt_argdecls","argdecls","argdecl","opt_argdefines","argdefines","args",
"argdefine","opt_dotdotdot","opt_expr","for_exprs","expr","opt_exprs","exprs",
"simpleexpr","opt_actuals","actuals","comma_expr","assignop","opt_integer",
"integer","doc_string","opt_comment","opt_arrayinit","arrayinit","arrayelts",
"arrayelt","opt_hashinit","hashinit","hashelts","hashelt","hashvalue",
"structinit","structelts","structelt","init","pcommand","command","reset",
"eend","ignorenl","attendnl","not_command","opt_nl","opt_semi","opt_comma",
"namespace_start","namespace_end","block_start","block_end","union_or_enum",
"$$1","$$2","see_comment","$$3","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish opt_class opt_type opt_nl",
"decl : class opt_type opt_nl",
"decl : type opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"type : type PLUS type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"opt_class : class",
"opt_class :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : ISTYPE OP simpleexpr COMMA type CP",
"simpleexpr : HASMEMBER OP simpleexpr COMMA NAME CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGNOR",
"assignop : ASSIGNAND",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"structelt : DOT NAME ASSIGN simpleexpr",
"structelt : DOT NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 1632 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
#line 4034 "gram.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 5:
#line 197 "gram.y"
	{ yyerrok; }
#line 4707 "gram.c"
break;
case 6:
#line 199 "gram.y"
	{ yyerrok; }
#line 4712 "gram.c"
break;
case 7:
#line 201 "gram.y"
	{ yyerrok; }
#line 4717 "gram.c"
break;
case 8:
#line 209 "gram.y"
	{ ignorenl++; }
#line 4722 "gram.c"
break;
case 9:
#line 212 "gram.y"
	{ if (ignorenl > 0) ignorenl--; }
#line 4727 "gram.c"
break;
case 10:
#line 215 "gram.y"
	{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
			lastThreadError = True;
		    }
#line 4739 "gram.c"
break;
case 11:
#line 233 "gram.y"
	{ notCommand = 1; }
#line 4744 "gram.c"
break;
case 18:
#line 248 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yystack.l_mark[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 4763 "gram.c"
break;
case 19:
#line 264 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yystack.l_mark[-4].expr, 0), yystack.l_mark[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 4782 "gram.c"
break;
case 20:
#line 280 "gram.y"
	{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yystack.l_mark[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 4798 "gram.c"
break;
case 21:
#line 293 "gram.y"
	{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
#line 4825 "gram.c"
break;
case 22:
#line 317 "gram.y"
	{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
#line 4853 "gram.c"
break;
case 26:
#line 346 "gram.y"
	{ yyval.expr = 0; }
#line 4858 "gram.c"
break;
case 27:
#line 349 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 4863 "gram.c"
break;
case 28:
#line 351 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
#line 4868 "gram.c"
break;
case 29:
#line 354 "gram.y"
	{ yyval.expr = BuildRawname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom); }
#line 4873 "gram.c"
break;
case 33:
#line 361 "gram.y"
	{ yyval.expr = NewExprTree (COLONCOLON, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[-1].atom, 0, False)); }
#line 4878 "gram.c"
break;
case 34:
#line 363 "gram.y"
	{ yyval.expr = 0; }
#line 4883 "gram.c"
break;
case 35:
#line 366 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
#line 4891 "gram.c"
break;
case 36:
#line 371 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
#line 4899 "gram.c"
break;
case 37:
#line 377 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
#line 4907 "gram.c"
break;
case 38:
#line 382 "gram.y"
	{
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
#line 4915 "gram.c"
break;
case 39:
#line 388 "gram.y"
	{
			yyval.expr = yystack.l_mark[0].expr;
		    }
#line 4922 "gram.c"
break;
case 40:
#line 392 "gram.y"
	{
			yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr);
		    }
#line 4929 "gram.c"
break;
case 41:
#line 397 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yystack.l_mark[-2].expr, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
#line 4955 "gram.c"
break;
case 42:
#line 420 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
#line 4981 "gram.c"
break;
case 45:
#line 450 "gram.y"
	{ CurrentNamespace = NewNamespace (CurrentNamespace); }
#line 4986 "gram.c"
break;
case 46:
#line 453 "gram.y"
	{ CurrentNamespace = CurrentNamespace->previous; }
#line 4991 "gram.c"
break;
case 47:
#line 456 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 4996 "gram.c"
break;
case 50:
#line 463 "gram.y"
	{ yyval.expr = NewExprTree(OC, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
#line 5001 "gram.c"
break;
case 51:
#line 465 "gram.y"
	{ yyval.expr = NewExprTree(OC, 0, 0); }
#line 5006 "gram.c"
break;
case 52:
#line 468 "gram.y"
	{ yyval.expr = NewExprTree(IF, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5011 "gram.c"
break;
case 53:
#line 470 "gram.y"
	{ yyval.expr = NewExprTree(ELSE, yystack.l_mark[-4].expr, NewExprTree(ELSE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
#line 5016 "gram.c"
break;
case 56:
#line 477 "gram.y"
	{ yyval.expr = yystack.l_mark[-2].expr; }
#line 5021 "gram.c"
break;
case 57:
#line 479 "gram.y"
	{ yyval.expr = NewExprTree(WHILE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
#line 5026 "gram.c"
break;
case 58:
#line 481 "gram.y"
	{ yyval.expr = NewExprTree(DO, yystack.l_mark[-6].expr, yystack.l_mark[-3].expr); }
#line 5031 "gram.c"
break;
case 59:
#line 483 "gram.y"
	{ Expr *expr = ParseCanonFor(yystack.l_mark[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yystack.l_mark[-2].expr); }
#line 5039 "gram.c"
break;
case 60:
#line 488 "gram.y"
	{ yyval.expr = NewExprTree (SWITCH, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
#line 5044 "gram.c"
break;
case 61:
#line 490 "gram.y"
	{ yyval.expr = NewExprTree (UNION, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
#line 5049 "gram.c"
break;
case 62:
#line 492 "gram.y"
	{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
#line 5054 "gram.c"
break;
case 63:
#line 494 "gram.y"
	{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
#line 5059 "gram.c"
break;
case 64:
#line 496 "gram.y"
	{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yystack.l_mark[-1].expr); }
#line 5064 "gram.c"
break;
case 65:
#line 498 "gram.y"
	{ yyval.expr = NewExprTree(EXPR, yystack.l_mark[-1].expr, (Expr *) 0); }
#line 5069 "gram.c"
break;
case 66:
#line 500 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
#line 5074 "gram.c"
break;
case 67:
#line 502 "gram.y"
	{ 
			DeclList    *decl = yystack.l_mark[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yystack.l_mark[-3].funcDecl.type.class;
			Publish	    publish = yystack.l_mark[-3].funcDecl.type.publish;
			TypePtr	    type = yystack.l_mark[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yystack.l_mark[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yystack.l_mark[-1].expr,
								       yystack.l_mark[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
#line 5104 "gram.c"
break;
case 68:
#line 529 "gram.y"
	{ 
			DeclListPtr decl;

			decl = NewDeclList (yystack.l_mark[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yystack.l_mark[-9].publish, 
						       class_exception, 
						       typePoly, yystack.l_mark[-6].atom);
			decl->symbol->exception.doc = yystack.l_mark[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yystack.l_mark[-4].argType),
					  yystack.l_mark[-9].publish);
		    }
#line 5122 "gram.c"
break;
case 69:
#line 544 "gram.y"
	{ yyval.expr = NewExprTree (RAISE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
#line 5127 "gram.c"
break;
case 70:
#line 546 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, 0, yystack.l_mark[-5].publish), 0);
		    }
#line 5139 "gram.c"
break;
case 71:
#line 555 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-6].publish, class_typedef,
							   yystack.l_mark[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, yystack.l_mark[-3].type, yystack.l_mark[-6].publish), 0);
		    }
#line 5151 "gram.c"
break;
case 72:
#line 564 "gram.y"
	{
			SymbolPtr   symbol;
			Publish	    publish = yystack.l_mark[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yystack.l_mark[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].publish, class_namespace,
						     0, yystack.l_mark[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yystack.l_mark[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
#line 5195 "gram.c"
break;
case 73:
#line 605 "gram.y"
	{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yystack.l_mark[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yystack.l_mark[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yystack.l_mark[-5].atom, 0, False), yystack.l_mark[-2].expr);
		    }
#line 5212 "gram.c"
break;
case 74:
#line 619 "gram.y"
	{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yystack.l_mark[-2].expr;
			for (p = yystack.l_mark[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yystack.l_mark[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yystack.l_mark[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yystack.l_mark[-5].publish));
		    }
#line 5255 "gram.c"
break;
case 75:
#line 659 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 5260 "gram.c"
break;
case 76:
#line 661 "gram.y"
	{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yystack.l_mark[-6].expr, yystack.l_mark[-4].expr),
					NewExprTree (TWIXT, yystack.l_mark[-2].expr, 0));
		    }
#line 5268 "gram.c"
break;
case 77:
#line 667 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5273 "gram.c"
break;
case 78:
#line 669 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[0].expr, 0); }
#line 5278 "gram.c"
break;
case 80:
#line 674 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 5283 "gram.c"
break;
case 81:
#line 677 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[0].expr, yystack.l_mark[-1].expr); }
#line 5288 "gram.c"
break;
case 82:
#line 681 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
#line 5293 "gram.c"
break;
case 83:
#line 683 "gram.y"
	{ yyval.expr = 0; }
#line 5298 "gram.c"
break;
case 84:
#line 686 "gram.y"
	{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value),
					yystack.l_mark[-5].expr); 
		    }
#line 5306 "gram.c"
break;
case 86:
#line 693 "gram.y"
	{ yyval.expr = 0; }
#line 5311 "gram.c"
break;
case 87:
#line 695 "gram.y"
	{ ++funcDepth; }
#line 5316 "gram.c"
break;
case 88:
#line 695 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
#line 5321 "gram.c"
break;
case 89:
#line 698 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
#line 5326 "gram.c"
break;
case 90:
#line 700 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
#line 5335 "gram.c"
break;
case 93:
#line 710 "gram.y"
	{ seeComment = 1; }
#line 5340 "gram.c"
break;
case 94:
#line 713 "gram.y"
	{ seeComment = 0; yyval.value = yystack.l_mark[0].value; }
#line 5345 "gram.c"
break;
case 96:
#line 717 "gram.y"
	{ yyval.value = Void; }
#line 5350 "gram.c"
break;
case 97:
#line 720 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 5355 "gram.c"
break;
case 98:
#line 723 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
#line 5360 "gram.c"
break;
case 99:
#line 725 "gram.y"
	{ yyval.expr = 0; }
#line 5365 "gram.c"
break;
case 100:
#line 728 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5370 "gram.c"
break;
case 101:
#line 730 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
#line 5375 "gram.c"
break;
case 102:
#line 733 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 5380 "gram.c"
break;
case 103:
#line 736 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
#line 5385 "gram.c"
break;
case 104:
#line 738 "gram.y"
	{ yyval.expr = 0; }
#line 5390 "gram.c"
break;
case 105:
#line 741 "gram.y"
	{ 
			SymbolPtr   sym = yystack.l_mark[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yystack.l_mark[-4].atom, 0, False),
						       name),
					  yystack.l_mark[-1].expr);
		    }
#line 5408 "gram.c"
break;
case 106:
#line 756 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
#line 5413 "gram.c"
break;
case 107:
#line 759 "gram.y"
	{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yystack.l_mark[0].atom);
		    }
#line 5423 "gram.c"
break;
case 108:
#line 766 "gram.y"
	{ yyval.symbol = 0; }
#line 5428 "gram.c"
break;
case 109:
#line 772 "gram.y"
	{ yyval.atomList = NewAtomList (yystack.l_mark[0].atomList, yystack.l_mark[-2].atom); }
#line 5433 "gram.c"
break;
case 110:
#line 774 "gram.y"
	{ yyval.atomList = NewAtomList (0, yystack.l_mark[0].atom); }
#line 5438 "gram.c"
break;
case 111:
#line 777 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[-2].atom, 0, yystack.l_mark[0].declList); }
#line 5443 "gram.c"
break;
case 112:
#line 779 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[0].atom, 0, 0); }
#line 5448 "gram.c"
break;
case 115:
#line 793 "gram.y"
	{ 
			if (yystack.l_mark[-3].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-3].symbol->symbol.name, yystack.l_mark[-2].expr, yystack.l_mark[0].declList); 
			    yyval.declList->symbol = yystack.l_mark[-3].symbol;
			}
			else
			    yyval.declList = yystack.l_mark[0].declList;
		    }
#line 5461 "gram.c"
break;
case 116:
#line 803 "gram.y"
	{ 
			if (yystack.l_mark[-1].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-1].symbol->symbol.name, yystack.l_mark[0].expr, 0);
			    yyval.declList->symbol = yystack.l_mark[-1].symbol;
			}
			else
			    yystack.l_mark[-1].symbol = 0;
		    }
#line 5474 "gram.c"
break;
case 117:
#line 814 "gram.y"
	{	
			yyval.symbol = ParseNewSymbol (yystack.l_mark[-1].fulltype.publish,
					     yystack.l_mark[-1].fulltype.class,
					     yystack.l_mark[-1].fulltype.type,
					     yystack.l_mark[0].atom);
		    }
#line 5484 "gram.c"
break;
case 118:
#line 826 "gram.y"
	{ yyval.fulltype = yystack.l_mark[-3].fulltype; }
#line 5489 "gram.c"
break;
case 119:
#line 832 "gram.y"
	{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yystack.l_mark[-3].funcDecl.type.type, yystack.l_mark[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yystack.l_mark[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].funcDecl.type.publish,
						     yystack.l_mark[-3].funcDecl.type.class, 
						     type,
						     yystack.l_mark[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yystack.l_mark[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
#line 5524 "gram.c"
break;
case 120:
#line 865 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
#line 5529 "gram.c"
break;
case 121:
#line 867 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
#line 5534 "gram.c"
break;
case 122:
#line 869 "gram.y"
	{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); 
		    }
#line 5544 "gram.c"
break;
case 123:
#line 877 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
#line 5549 "gram.c"
break;
case 124:
#line 879 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
#line 5554 "gram.c"
break;
case 125:
#line 881 "gram.y"
	{ yyval.expr = 0; }
#line 5559 "gram.c"
break;
case 126:
#line 887 "gram.y"
	{ yyval.fulltype.publish = yystack.l_mark[-3].publish; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
#line 5564 "gram.c"
break;
case 127:
#line 889 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
#line 5569 "gram.c"
break;
case 128:
#line 891 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yystack.l_mark[-1].type; }
#line 5574 "gram.c"
break;
case 129:
#line 897 "gram.y"
	{ yyval.type = NewTypeFunc (yystack.l_mark[0].type, yystack.l_mark[-1].argType); }
#line 5579 "gram.c"
break;
case 130:
#line 899 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
#line 5584 "gram.c"
break;
case 131:
#line 901 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, True); }
#line 5589 "gram.c"
break;
case 132:
#line 903 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
#line 5594 "gram.c"
break;
case 133:
#line 905 "gram.y"
	{ yyval.type = NewTypeHash (yystack.l_mark[0].type, yystack.l_mark[-2].type); }
#line 5599 "gram.c"
break;
case 134:
#line 907 "gram.y"
	{ yyval.type = 0; }
#line 5604 "gram.c"
break;
case 135:
#line 910 "gram.y"
	{
			Type	*top = yystack.l_mark[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yystack.l_mark[-1].type;
			yyval.type = top;
		    }
#line 5635 "gram.c"
break;
case 136:
#line 938 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, True); }
#line 5640 "gram.c"
break;
case 137:
#line 940 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, True), True); }
#line 5645 "gram.c"
break;
case 138:
#line 942 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, False), False); }
#line 5650 "gram.c"
break;
case 139:
#line 944 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, False); }
#line 5655 "gram.c"
break;
case 140:
#line 946 "gram.y"
	{ 
			if (ParseCanonType (yystack.l_mark[-2].type, False) != CanonTypeDefined)
			    YYERROR;
			if (ParseCanonType (yystack.l_mark[0].type, False) != CanonTypeDefined)
			    YYERROR;
			yyval.type = NewTypePlus (yystack.l_mark[-2].type, yystack.l_mark[0].type); 
			if (!yyval.type)
			    YYERROR;
		    }
#line 5668 "gram.c"
break;
case 142:
#line 958 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
#line 5697 "gram.c"
break;
case 143:
#line 984 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
#line 5726 "gram.c"
break;
case 144:
#line 1010 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
#line 5749 "gram.c"
break;
case 145:
#line 1031 "gram.y"
	{ yyval.type = yystack.l_mark[-1].type; }
#line 5754 "gram.c"
break;
case 146:
#line 1033 "gram.y"
	{ yyval.type = NewTypeName (yystack.l_mark[0].expr, 0); }
#line 5759 "gram.c"
break;
case 148:
#line 1037 "gram.y"
	{ yyval.type = typePoly; }
#line 5764 "gram.c"
break;
case 163:
#line 1055 "gram.y"
	{ yyval.expr = 0; }
#line 5769 "gram.c"
break;
case 164:
#line 1058 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
#line 5774 "gram.c"
break;
case 165:
#line 1060 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
#line 5779 "gram.c"
break;
case 166:
#line 1063 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
#line 5784 "gram.c"
break;
case 167:
#line 1065 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
#line 5789 "gram.c"
break;
case 168:
#line 1068 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5794 "gram.c"
break;
case 169:
#line 1070 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
#line 5799 "gram.c"
break;
case 170:
#line 1076 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
#line 5804 "gram.c"
break;
case 171:
#line 1078 "gram.y"
	{ yyval.memList = 0; }
#line 5809 "gram.c"
break;
case 172:
#line 1081 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
#line 5814 "gram.c"
break;
case 173:
#line 1083 "gram.y"
	{ yyval.memList = 0; }
#line 5819 "gram.c"
break;
case 175:
#line 1090 "gram.y"
	{ yyval.class = class_undef; }
#line 5824 "gram.c"
break;
case 181:
#line 1099 "gram.y"
	{ yyval.publish = publish_private; }
#line 5829 "gram.c"
break;
case 186:
#line 1113 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
#line 5834 "gram.c"
break;
case 187:
#line 1115 "gram.y"
	{ yyval.argType = 0; }
#line 5839 "gram.c"
break;
case 188:
#line 1118 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
#line 5844 "gram.c"
break;
case 189:
#line 1120 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
#line 5849 "gram.c"
break;
case 190:
#line 1123 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-1].type, False);
			yyval.argDecl.type = yystack.l_mark[-1].type; 
			yyval.argDecl.name = yystack.l_mark[0].atom; 
		    }
#line 5858 "gram.c"
break;
case 191:
#line 1129 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[0].type, False);
			yyval.argDecl.type = yystack.l_mark[0].type;
			yyval.argDecl.name = 0; 
		    }
#line 5867 "gram.c"
break;
case 192:
#line 1140 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
#line 5872 "gram.c"
break;
case 193:
#line 1143 "gram.y"
	{
			ArgType	*args;
			Type	*type;

			for (args = yystack.l_mark[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yystack.l_mark[0].argType;
		    }
#line 5900 "gram.c"
break;
case 194:
#line 1168 "gram.y"
	{ yyval.argType = 0; }
#line 5905 "gram.c"
break;
case 195:
#line 1171 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
#line 5910 "gram.c"
break;
case 196:
#line 1173 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
#line 5915 "gram.c"
break;
case 197:
#line 1176 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[-1].type; yyval.argDecl.name = yystack.l_mark[0].atom; }
#line 5920 "gram.c"
break;
case 198:
#line 1178 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[0].type; yyval.argDecl.name = 0; }
#line 5925 "gram.c"
break;
case 199:
#line 1181 "gram.y"
	{ yyval.bool = True; }
#line 5930 "gram.c"
break;
case 200:
#line 1183 "gram.y"
	{ yyval.bool = False; }
#line 5935 "gram.c"
break;
case 202:
#line 1191 "gram.y"
	{ yyval.expr = 0; }
#line 5940 "gram.c"
break;
case 204:
#line 1195 "gram.y"
	{ 
			DeclList    *decl;

			for (decl = yystack.l_mark[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yystack.l_mark[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yystack.l_mark[0].declList, yystack.l_mark[-1].fulltype.class, yystack.l_mark[-1].fulltype.type, yystack.l_mark[-1].fulltype.publish); 
		    }
#line 5958 "gram.c"
break;
case 206:
#line 1212 "gram.y"
	{ yyval.expr = NewExprTree(COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5963 "gram.c"
break;
case 208:
#line 1219 "gram.y"
	{ yyval.expr = 0; }
#line 5968 "gram.c"
break;
case 209:
#line 1222 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5973 "gram.c"
break;
case 210:
#line 1224 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
#line 5978 "gram.c"
break;
case 212:
#line 1228 "gram.y"
	{ yyval.expr = 0; }
#line 5983 "gram.c"
break;
case 213:
#line 1231 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 5988 "gram.c"
break;
case 214:
#line 1233 "gram.y"
	{	
			ExprPtr	arg = yystack.l_mark[0].bool ? NewExprTree (DOTDOTDOT, yystack.l_mark[-1].expr, 0) : yystack.l_mark[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
#line 5996 "gram.c"
break;
case 215:
#line 1239 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
#line 6005 "gram.c"
break;
case 216:
#line 1244 "gram.y"
	{ ++funcDepth; }
#line 6010 "gram.c"
break;
case 217:
#line 1244 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
#line 6015 "gram.c"
break;
case 218:
#line 1250 "gram.y"
	{ 
			if (yystack.l_mark[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr));
			else
			{
			    ExprPtr left = yystack.l_mark[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yystack.l_mark[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yystack.l_mark[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yystack.l_mark[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yystack.l_mark[-1].ints, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); 
			}
		    }
#line 6044 "gram.c"
break;
case 219:
#line 1276 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yystack.l_mark[-6].type, yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value), 0); 
		    }
#line 6052 "gram.c"
break;
case 220:
#line 1281 "gram.y"
	{   Value	t;
			t = do_Thread_id_to_thread (yystack.l_mark[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yystack.l_mark[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
#line 6066 "gram.c"
break;
case 221:
#line 1292 "gram.y"
	{ yyval.expr = NewExprTree(STAR, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6071 "gram.c"
break;
case 222:
#line 1294 "gram.y"
	{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yystack.l_mark[0].expr, 0), 0); }
#line 6076 "gram.c"
break;
case 223:
#line 1296 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6081 "gram.c"
break;
case 224:
#line 1298 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yystack.l_mark[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
#line 6088 "gram.c"
break;
case 225:
#line 1302 "gram.y"
	{ yyval.expr = NewExprTree(UMINUS, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6093 "gram.c"
break;
case 226:
#line 1304 "gram.y"
	{ yyval.expr = NewExprTree(LNOT, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6098 "gram.c"
break;
case 227:
#line 1306 "gram.y"
	{ yyval.expr = NewExprTree(BANG, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6103 "gram.c"
break;
case 228:
#line 1308 "gram.y"
	{ 
			yyval.expr = NewExprTree(FACT, 
					 BuildName ("Math", "factorial"),
					 yystack.l_mark[-1].expr);
		    }
#line 6112 "gram.c"
break;
case 229:
#line 1314 "gram.y"
	{ yyval.expr = NewExprTree(INC, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6117 "gram.c"
break;
case 230:
#line 1316 "gram.y"
	{ yyval.expr = NewExprTree(INC, (Expr *) 0, yystack.l_mark[-1].expr); }
#line 6122 "gram.c"
break;
case 231:
#line 1318 "gram.y"
	{ yyval.expr = NewExprTree(DEC, yystack.l_mark[0].expr, (Expr *) 0); }
#line 6127 "gram.c"
break;
case 232:
#line 1320 "gram.y"
	{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yystack.l_mark[-1].expr); }
#line 6132 "gram.c"
break;
case 233:
#line 1322 "gram.y"
	{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yystack.l_mark[0].expr); }
#line 6137 "gram.c"
break;
case 234:
#line 1324 "gram.y"
	{ yyval.expr = NewExprTree(PLUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6142 "gram.c"
break;
case 235:
#line 1326 "gram.y"
	{ yyval.expr = NewExprTree(MINUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6147 "gram.c"
break;
case 236:
#line 1328 "gram.y"
	{ yyval.expr = NewExprTree(TIMES, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6152 "gram.c"
break;
case 237:
#line 1330 "gram.y"
	{ yyval.expr = NewExprTree(DIVIDE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6157 "gram.c"
break;
case 238:
#line 1332 "gram.y"
	{ yyval.expr = NewExprTree(DIV, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6162 "gram.c"
break;
case 239:
#line 1334 "gram.y"
	{ yyval.expr = NewExprTree(MOD, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6167 "gram.c"
break;
case 240:
#line 1336 "gram.y"
	{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); 
		    }
#line 6176 "gram.c"
break;
case 241:
#line 1342 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
#line 6187 "gram.c"
break;
case 242:
#line 1350 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
#line 6198 "gram.c"
break;
case 243:
#line 1358 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTL, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6203 "gram.c"
break;
case 244:
#line 1360 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6208 "gram.c"
break;
case 245:
#line 1362 "gram.y"
	{ yyval.expr = NewExprTree(QUEST, yystack.l_mark[-4].expr, NewExprTree(COLON, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
#line 6213 "gram.c"
break;
case 246:
#line 1364 "gram.y"
	{ yyval.expr = NewExprTree(LXOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6218 "gram.c"
break;
case 247:
#line 1366 "gram.y"
	{ yyval.expr = NewExprTree(LAND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6223 "gram.c"
break;
case 248:
#line 1368 "gram.y"
	{ yyval.expr = NewExprTree(LOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6228 "gram.c"
break;
case 249:
#line 1370 "gram.y"
	{ yyval.expr = NewExprTree(AND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6233 "gram.c"
break;
case 250:
#line 1372 "gram.y"
	{ yyval.expr = NewExprTree(OR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6238 "gram.c"
break;
case 251:
#line 1374 "gram.y"
	{ yyval.expr = NewExprTree(EQ, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6243 "gram.c"
break;
case 252:
#line 1376 "gram.y"
	{ yyval.expr = NewExprTree(NE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6248 "gram.c"
break;
case 253:
#line 1378 "gram.y"
	{ yyval.expr = NewExprTree(LT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6253 "gram.c"
break;
case 254:
#line 1380 "gram.y"
	{ yyval.expr = NewExprTree(GT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6258 "gram.c"
break;
case 255:
#line 1382 "gram.y"
	{ yyval.expr = NewExprTree(LE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6263 "gram.c"
break;
case 256:
#line 1384 "gram.y"
	{ yyval.expr = NewExprTree(GE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6268 "gram.c"
break;
case 258:
#line 1387 "gram.y"
	{ yyval.expr = NewExprConst(TEN_NUM, yystack.l_mark[0].value); }
#line 6273 "gram.c"
break;
case 259:
#line 1389 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_NUM, yystack.l_mark[0].value); }
#line 6278 "gram.c"
break;
case 260:
#line 1391 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_NUM, yystack.l_mark[0].value); }
#line 6283 "gram.c"
break;
case 261:
#line 1393 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_NUM, yystack.l_mark[0].value); }
#line 6288 "gram.c"
break;
case 262:
#line 1395 "gram.y"
	{ yyval.expr = NewExprConst(HEX_NUM, yystack.l_mark[0].value); }
#line 6293 "gram.c"
break;
case 263:
#line 1397 "gram.y"
	{ yyval.expr = NewExprConst(TEN_FLOAT, yystack.l_mark[0].value); }
#line 6298 "gram.c"
break;
case 264:
#line 1399 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_FLOAT, yystack.l_mark[0].value); }
#line 6303 "gram.c"
break;
case 265:
#line 1401 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yystack.l_mark[0].value); }
#line 6308 "gram.c"
break;
case 266:
#line 1403 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_FLOAT, yystack.l_mark[0].value); }
#line 6313 "gram.c"
break;
case 267:
#line 1405 "gram.y"
	{ yyval.expr = NewExprConst(HEX_FLOAT, yystack.l_mark[0].value); }
#line 6318 "gram.c"
break;
case 268:
#line 1407 "gram.y"
	{ yyval.expr = NewExprConst(CHAR_CONST, yystack.l_mark[0].value); }
#line 6323 "gram.c"
break;
case 269:
#line 1409 "gram.y"
	{ yyval.expr = NewExprConst(STRING_CONST, yystack.l_mark[0].value); }
#line 6328 "gram.c"
break;
case 270:
#line 1411 "gram.y"
	{ yyval.expr = NewExprConst(VOIDVAL, yystack.l_mark[0].value); }
#line 6333 "gram.c"
break;
case 271:
#line 1413 "gram.y"
	{ yyval.expr = NewExprConst(BOOLVAL, yystack.l_mark[0].value); }
#line 6338 "gram.c"
break;
case 272:
#line 1415 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
#line 6345 "gram.c"
break;
case 273:
#line 1419 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = yystack.l_mark[-4].type;
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
#line 6356 "gram.c"
break;
case 274:
#line 1427 "gram.y"
	{ 
			yystack.l_mark[-1].expr->base.type = NewTypeArray (typePoly, yystack.l_mark[-5].expr, True); 
			ParseCanonType (yystack.l_mark[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			yyval.expr->base.type = yystack.l_mark[-1].expr->base.type;
		    }
#line 6366 "gram.c"
break;
case 275:
#line 1434 "gram.y"
	{ 
			TypePtr	t = NewTypeArray (typePoly, yystack.l_mark[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
#line 6378 "gram.c"
break;
case 276:
#line 1443 "gram.y"
	{
			TypePtr t = NewTypeHash (typePoly, yystack.l_mark[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
#line 6390 "gram.c"
break;
case 277:
#line 1452 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[0].atom, 0, False), 0); 
			yyval.expr->base.type = yystack.l_mark[-2].type;
		    }
#line 6399 "gram.c"
break;
case 278:
#line 1458 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); 
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
#line 6408 "gram.c"
break;
case 279:
#line 1464 "gram.y"
	{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yystack.l_mark[0].value)); }
#line 6413 "gram.c"
break;
case 280:
#line 1466 "gram.y"
	{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
#line 6418 "gram.c"
break;
case 281:
#line 1468 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 6423 "gram.c"
break;
case 282:
#line 1470 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
#line 6428 "gram.c"
break;
case 283:
#line 1472 "gram.y"
	{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yystack.l_mark[-3].expr, (Expr *) 0), yystack.l_mark[-1].expr); }
#line 6433 "gram.c"
break;
case 284:
#line 1474 "gram.y"
	{ yyval.expr = NewExprTree(OS, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
#line 6438 "gram.c"
break;
case 285:
#line 1476 "gram.y"
	{ yyval.expr = NewExprTree (OP, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
#line 6443 "gram.c"
break;
case 286:
#line 1478 "gram.y"
	{
			TypePtr	type = yystack.l_mark[-1].type;
			ParseCanonType (type, False);
			yyval.expr = NewExprType (ISTYPE, yystack.l_mark[-3].expr, type);
		    }
#line 6452 "gram.c"
break;
case 287:
#line 1484 "gram.y"
	{ yyval.expr = NewExprTree (HASMEMBER, yystack.l_mark[-3].expr, NewExprAtom(yystack.l_mark[-1].atom, 0, False)); }
#line 6457 "gram.c"
break;
case 288:
#line 1486 "gram.y"
	{ yyval.expr = NewExprTree(DOT, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
#line 6462 "gram.c"
break;
case 289:
#line 1488 "gram.y"
	{ yyval.expr = NewExprTree(ARROW, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
#line 6467 "gram.c"
break;
case 291:
#line 1492 "gram.y"
	{ yyval.value = Zero; }
#line 6472 "gram.c"
break;
case 313:
#line 1520 "gram.y"
	{ yyval.expr = 0; }
#line 6477 "gram.c"
break;
case 314:
#line 1522 "gram.y"
	{ yyval.expr = 0; }
#line 6482 "gram.c"
break;
case 315:
#line 1525 "gram.y"
	{ 
			ExprPtr	elts = yystack.l_mark[-3].expr ? ExprRehang (yystack.l_mark[-3].expr, 0) : 0;
			if (yystack.l_mark[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
#line 6499 "gram.c"
break;
case 316:
#line 1539 "gram.y"
	{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yystack.l_mark[-5].expr, yystack.l_mark[-4].expr), yystack.l_mark[-2].expr);
		    }
#line 6506 "gram.c"
break;
case 317:
#line 1544 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
#line 6511 "gram.c"
break;
case 319:
#line 1548 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6516 "gram.c"
break;
case 321:
#line 1552 "gram.y"
	{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yystack.l_mark[0].atom);
			yyval.expr = NewExprAtom (yystack.l_mark[0].atom, s, False); 
		    }
#line 6526 "gram.c"
break;
case 322:
#line 1560 "gram.y"
	{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
#line 6537 "gram.c"
break;
case 323:
#line 1569 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6542 "gram.c"
break;
case 324:
#line 1571 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
#line 6547 "gram.c"
break;
case 328:
#line 1582 "gram.y"
	{ yyval.expr = 0; }
#line 6552 "gram.c"
break;
case 329:
#line 1584 "gram.y"
	{ yyval.expr = 0; }
#line 6557 "gram.c"
break;
case 330:
#line 1587 "gram.y"
	{
			ExprPtr elts = yystack.l_mark[-2].expr ? ExprRehang (yystack.l_mark[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
#line 6565 "gram.c"
break;
case 331:
#line 1593 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6570 "gram.c"
break;
case 332:
#line 1595 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
#line 6575 "gram.c"
break;
case 333:
#line 1598 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6580 "gram.c"
break;
case 334:
#line 1600 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, 0, yystack.l_mark[0].expr); }
#line 6585 "gram.c"
break;
case 337:
#line 1609 "gram.y"
	{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yystack.l_mark[-2].expr, 0), 0); }
#line 6590 "gram.c"
break;
case 338:
#line 1612 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
#line 6595 "gram.c"
break;
case 339:
#line 1614 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
#line 6600 "gram.c"
break;
case 340:
#line 1617 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
#line 6605 "gram.c"
break;
case 341:
#line 1619 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
#line 6610 "gram.c"
break;
case 342:
#line 1621 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
#line 6615 "gram.c"
break;
case 343:
#line 1623 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
#line 6620 "gram.c"
break;
case 347:
#line 1629 "gram.y"
	{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
#line 6625 "gram.c"
break;
#line 6627 "gram.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
